(*
    #######################################################

    ړI    :   WinSock.pas ̃\Pbg֐̃bp[
        :   2003/08/10 쐬

    Ql    :   C/C++300̋Z 
            :   http://www.asahi-net.or.jp/~nk2w-ishr/ 

    #######################################################
*)

unit iWinSock;

interface

uses
    Windows, SysUtils, Classes, WinSock;

function    socket(): TSocket;
procedure   closesocket(s: TSocket);
function    MakeSockAddr(APort: integer; IPorName: string): TSockAddr;
procedure   connect(s: TSocket; var name: TSockaddr);

procedure   send(s: TSocket; stream: TStream); overload;
procedure   send(s: TSocket; command: string); overload;
procedure   send(s: TSocket; strings: TStrings); overload;

procedure   recv(s: TSocket; stream: TStream); overload;
procedure   recv(s: TSocket; strings: TStrings); overload;
function    recv(s: TSocket): string; overload;

function    recvonce(s: TSocket): string;
procedure   bind(s: TSocket; var name: TSockaddr);
procedure   listen(s: TSocket);
function    accept(s: TSocket; clientname: TSockaddr): TSocket;

var
    MaxSocketCount: integer = 0;

implementation

(*
    =======================================================
    ŐṼG[bZ[WOƂĐ
    -------------------------------------------------------
    IWi  :   Ȃ
            :   ƂȂ֐
    ߒl        :   Ȃ
    l        :   Ȃ
    =======================================================
*)
procedure   RaiseError(AFuncName: string);
begin
    raise Exception.CreateFmt('%s(iWinSock.pas):%s', [AFuncName, SysErrorMessage(WSAGetLastError)]);
end;

(*
    =======================================================
    Winsock gpJn錾
    -------------------------------------------------------
    IWi  :   WSAStartup
            :   Ȃ
    ߒl        :   쐬\\Pbg
    l        :   Version1.1O
    =======================================================
*)
function    WSAStartup(): integer;
const
    VERSION: WORD = $0101;
var
    WSAData: TWSAData;
begin
    if (Winsock.WSAStartup(VERSION, WSAData) = 0) and (WSAData.wVersion = VERSION) then
    begin
        Result := WSAData.iMaxSockets;
    end else
    begin
        Result := 0;
        RaiseError('WSAStartup');
    end;
end;

(*
    =======================================================
    Winsock gpI錾
    -------------------------------------------------------
    IWi  :   WSACleanup
            :   Ȃ
    ߒl        :   쐬\\Pbg
    l        :   Version1.1O
    =======================================================
*)
procedure   WSACleanup();
begin
    if Winsock.WSACleanup <> 0 then RaiseError('WSACleanup');
end;

(*
    =======================================================
    PHostEnt\̂h_aliaseso
    -------------------------------------------------------
    IWi  :   Ȃ
            :   PHostEnt
    ߒl        :   h_aliases,łȂ
    l        :   Ȃ
    =======================================================
*)
type
    PPChar = ^PChar;

function    HostAliases(HostEntry: PHostEnt): string;
var
    ppc: PPChar;
begin
    Result := '';
    try
        ppc := PPChar(HostEntry^.h_aliases);
        while Assigned(ppc^) do
        begin
            // ppc ́APPChar = ^PChar Ȃ̂ŁAppc^ = PChar ɂȂB
            Result := Result + ',' + ppc^;
            Inc(ppc);
        end;
        //1ڂA΂','ɂȂĂ̂łݑ|
        Result := Copy(Result, 2, Length(Result));
    except
        RaiseError('HostEntry^.h_aliases');
    end;
end;

(*
    =======================================================
    PHostEnt\̂h_addr_listo
    -------------------------------------------------------
    IWi  :   Ȃ
            :   PHostEnt
    ߒl        :   h_addr_list,łȂ
    l        :   Ȃ
    =======================================================
*)
function    HostAddressList(HostEntry: PHostEnt): string;
var
    ppc: PPChar;
begin
    Result := '';
    try
        ppc := PPChar(HostEntry^.h_addr_list);
        while Assigned(ppc^) do
        begin
            // ppc ́APPChar = ^PChar Ȃ̂ŁAppc^ = PChar ɂȂB
            Result := Result + ',' + inet_ntoa(PInAddr(ppc^)^);
            Inc(ppc);
        end;
        //1ڂA΂','ɂȂĂ̂łݑ|
        Result := Copy(Result, 2, MaxInt);
    except
        RaiseError('HostEntry^.h_addr_list');
    end;
end;

(*
    =======================================================
    IPAhXRs[^PHostEnt쐬    
    -------------------------------------------------------
    IWi  :   gethostbyaddr, gethostbyname
            :   IPAhX񂩃Rs[^   
    ߒl        :   PHostEnt
    l        :   Ȃ
    =======================================================
*)
function    gethostby(IPorName: string): PHostEnt;
var
    ip      : u_long;
begin
    // 10i\L?
    ip := inet_addr(PChar(IPorName));
    // ߂
    if ip = INADDR_NONE then
    begin
        Result := Winsock.gethostbyname(PChar(IPorName));
    end else
    // 
    begin
        Result := Winsock.gethostbyaddr(@ip, 4, AF_INET);
    end;
    // ܂
    if not Assigned(Result) then RaiseError('gethostby****');
end;

(*
    =======================================================
    IPAhXRs[^琮IPAhX쐬    
    -------------------------------------------------------
    IWi  :   Ȃ
            :   IPAhX񂩃Rs[^   
    ߒl        :   IPAhX
    l        :   Ȃ
    =======================================================
*)
function    InetAddress(IPorName: string): integer;
var
    HostEntry: PHostEnt;
begin
    // 肭ǂ
    HostEntry := gethostby(IPorName);
    // ŁA
    Result := inet_addr(inet_ntoa(PInAddr(HostEntry^.h_addr_list^)^));
end;

(*
    =======================================================
    socket
    -------------------------------------------------------
    IWi  :   socket
            :   Ȃ
    ߒl        :   TSocket
    l        :   TCP/IP
    =======================================================
*)
function    socket(): TSocket;
begin
    // ܂傤
    Result := Winsock.socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
    // ܂
    if Result = INVALID_SOCKET then RaiseError('socket');
end;
 
(*
    =======================================================
    socket̂Ă   
    -------------------------------------------------------
    IWi  :   closesocket
            :   TSocket   
    ߒl        :   Ȃ
    l        :   Ȃ
    =======================================================
*)
procedure   closesocket(s: TSocket);
begin
    // ̂Ă܂傤
    if Winsock.closesocket(s) = SOCKET_ERROR then RaiseError('closesocket');
end;

(*
    =======================================================
    TSockAddr쐬
    -------------------------------------------------------
    IWi  :   Ȃ
            :   |[gԍ
                    IPAhX񂩃Rs[^
    ߒl        :   TSockAddr
    l        :   Ȃ
    =======================================================
*)
function    MakeSockAddr(APort: integer; IPorName: string): TSockAddr;
begin
    FillChar(Result, SizeOf(TSockAddr), #0);
    Result.sin_family      := AF_INET;
    Result.sin_port        := htons(APort);
    if IPorName <> '' then
        Result.sin_addr.S_addr := InetAddress(IPorName)
    else
        Result.sin_addr.S_addr := INADDR_ANY        // T[o[p̂
    ;
end;

(*
    =======================================================
    ڑ
    -------------------------------------------------------
    IWi  :   connect
            :   TSocket
                    TSockAddr
    ߒl        :   Ȃ
    l        :   Ȃ
    =======================================================
*)
procedure   connect(s: TSocket; var name: TSockaddr);
begin
    if Winsock.connect(s, name, sizeof(name)) = SOCKET_ERROR then RaiseError('connect');
end;

(*
    =======================================================
       
    -------------------------------------------------------
    IWi  :   send
            :   TSocket
                    TStream
    ߒl        :   Ȃ
    l        :   XbhĂяoׂ
    =======================================================
*)
procedure   send(s: TSocket; stream: TStream);
var
    senddat: string;
    sendlen, sentlen: integer;
begin
    // stream ʒu
    stream.Position := 0;
    // M
    while True do
    begin
        // 
        senddat := '';
        SetLength(senddat, stream.Size);
        sendlen := stream.Read(senddat[1], stream.Size);
        // Ă݂
        sentlen := Winsock.send(s, senddat[1], sendlen, 0);
        // G[͂Ȃ?
        if sentlen = SOCKET_ERROR then
        begin
            RaiseError('send');
        end else
        // SĂˁ[
        if sentlen < sendlen then
        begin
            // ĂȂ߂
            stream.Seek(sendlen - sentlen, soFromCurrent);
        end else
        // Sꂽ
        begin
            Break;
        end;
    end;
end;

(*
    =======================================================
       
    -------------------------------------------------------
    IWi  :   send
            :   TSocket
                    M镶
    ߒl        :   Ȃ
    l        :   XbhĂяoׂ
    =======================================================
*)
procedure   send(s: TSocket; command: string);
var
    stream: TStream;
begin
    stream := TMemoryStream.Create;
    try
        stream.Write(command[1], Length(command));
        send(s, stream);
    finally
        stream.Free;
    end;
end;

(*
    =======================================================
    
    -------------------------------------------------------
    IWi  :   send
            :   TSocket
                    TStrings
    ߒl        :   Ȃ
    l        :   XbhĂяoׂ
    =======================================================
*)
procedure   send(s: TSocket; strings: TStrings);
var
    stream: TStream;
begin
    stream := TMemoryStream.Create;
    try
        strings.SaveToStream(stream);
        send(s, stream);
    finally
        stream.Free;
    end;
end;

(*
    =======================================================
    󂯂
    -------------------------------------------------------
    IWi  :   recv
            :   TSocket
                    TStream
    ߒl        :   Ȃ
    l        :   XbhĂяoׂ
    =======================================================
*)
procedure   recv(s: TSocket; stream: TStream);
var
    recvdat: string;
    recvlen: integer;
begin
    // M
    while True do
    begin
        // 
        recvdat := '';
        SetLength(recvdat, 8 * 1024);
        // 󂯂Ă݂
        recvlen := Winsock.recv(s, recvdat[1], Length(recvdat), 0);
        // G[͂Ȃ?
        if recvlen = SOCKET_ERROR then
        begin
            RaiseError('recv');
        end else
        // I
        if recvlen = 0 then
        begin
            Break;
        end else
        // ǂݎ
        begin
            stream.Write(recvdat[1], recvlen);
        end;
    end;
    // stream ʒu
    stream.Position := 0;
end;

(*
    =======================================================
    󂯂
    -------------------------------------------------------
    IWi  :   recv
            :   TSocket
                    TStrings
    ߒl        :   Ȃ
    l        :   XbhĂяoׂ
    =======================================================
*)
procedure   recv(s: TSocket; strings: TStrings);
var
    stream: TStream;
begin
    stream := TMemoryStream.Create;
    try
        recv(s, stream);
        strings.LoadFromStream(stream);
    finally
        stream.Free;
    end;
end;

(*
    =======================================================
    󂯂
    -------------------------------------------------------
    IWi  :   recv
            :   TSocket
    ߒl        :   string
    l        :   XbhĂяoׂ
    =======================================================
*)
function    recv(s: TSocket): string;
var
    stream: TStream;
    res: integer;
begin
    stream := TMemoryStream.Create;
    try
        recv(s, stream);
        SetLength(Result, stream.Size);
        res := stream.Read(Result[1], Length(Result));
        SetLength(Result, res);
    finally
        stream.Free;
    end;
end;

(*
    =======================================================
    󂯂(T[o̗vɏ̃[`gƉ̂)
    -------------------------------------------------------
    IWi  :   recv
            :   TSocket
    ߒl        :   string
    l        :   XbhĂяoׂ
    =======================================================
*)
function    recvonce(s: TSocket): string;
var
    recvlen: integer;
begin
    // 
    Result := '';
    SetLength(Result, 8 * 1024);
    // 󂯂Ă݂
    recvlen := Winsock.recv(s, Result[1], Length(Result), 0);
    // G[͂Ȃ?
    if recvlen = SOCKET_ERROR then RaiseError('recv');
    SetLength(Result, recvlen);
end;

(*
    =======================================================
    |[gԍƃvZXoCh   
    -------------------------------------------------------
    IWi  :   bind
            :   TSocket
                    TSockAddr
    ߒl        :   Ȃ
    l        :   Ȃ
    =======================================================
*)
procedure   bind(s: TSocket; var name: TSockaddr);
begin
    if Winsock.bind(s, name, sizeof(name)) = SOCKET_ERROR then RaiseError('bind');
end;

(*
    =======================================================
       
    -------------------------------------------------------
    IWi  :   listen
            :   TSocket
    ߒl        :   Ȃ
    l        :   Ȃ
    =======================================================
*)
procedure   listen(s: TSocket);
begin
    if Winsock.listen(s, SOMAXCONN) = SOCKET_ERROR then RaiseError('listen');
end;

(*
    =======================================================
    󂯕t   
    -------------------------------------------------------
    IWi  :   accept
            :   TSocket
                    TSockaddr
    ߒl        :   TSocket
    l        :   Ȃ
    =======================================================
*)
function    accept(s: TSocket; clientname: TSockaddr): TSocket;
var
    caddrlen: integer;
begin
    // TCY
    caddrlen := SizeOf(clientname);
    // 
    FillChar(clientname, SizeOf(TSockAddr), #0);
    // 󂯕t
    Result := Winsock.accept(s, @clientname, @caddrlen);
    // ܂?
    if Result = INVALID_SOCKET then RaiseError('accept');
end;

(*
    =======================================================
    /I   
    -------------------------------------------------------
    Winsock ̎gp/I
    =======================================================
*)
initialization
    try
        MaxSocketCount := WSAStartUp();
    except
        ;
    end;

finalization
    try
        WSACleanup();
    except
        ;
    end;

end.
